# TS5 Hotkeys

This project is a wrapper around the TeamSpeak 5 Remote Apps API to easily trigger actions from outside the main application.

Besides general automation purposes it can be useful when using Wayland, because currently native TS5 key bindings only work within X.

## Installation

First make sure Remote Apps are actually enabled in the TS5 options.

Then clone this repository and run `npm ci` to install all dependencies.

During the first run of `./index.js` there will be a notification within TS5 to allow this app to connect to the TS5 client.

## General Usage

Call `./index.js <button>`, where `<button>` is a unique button name. It will then send the corresponding key-down and key-up events to the TS5 client.

`<button>` is just some string, it doesn't have to match the actual key binding name.


## Adding Key Bindings

Open the TS5 key bindings dialogue, click on the key you want to bind to the script and call the script.

Because the TS5 window must not lose focus during this it's easiest to call the script with some sleep, click on "Choose" button in the TS5 window and then wait for the sleep to expire.

For example like this:

```bash
sleep 3 && ./index.js microphone
# while it's sleeping click on "Microphone" in the TS5 Key Bindings menu.
# wait up to 3 seconds
# you now should see an unique identifier as key binding, that ends with ":microphone"
./index.js microphone
# the microphone got toggled
```
